## AgsLevel

AgsLevel — A level widget

## Stability Level

Stable, unless otherwise indicated

## Functions

void | ags_level_set_upper ()
gdouble | ags_level_get_upper ()
void | ags_level_set_lower ()
gdouble | ags_level_get_lower ()
void | ags_level_set_normalized_volume ()
gdouble | ags_level_get_normalized_volume ()
void | ags_level_set_data_format ()
void | ags_level_set_samplerate ()
void | ags_level_value_changed ()
AgsLevel * | ags_level_new ()

## Properties

guint | data-format | Read / Write
double | lower | Read / Write
double | normalized-volume | Read / Write
guint | samplerate | Read / Write
double | upper | Read / Write

## Signals

void | value-changed | Run Last

## Types and Values

#define | AGS_LEVEL_DEFAULT_WIDTH_REQUEST
#define | AGS_LEVEL_DEFAULT_HEIGHT_REQUEST
#define | AGS_LEVEL_DEFAULT_LOWER
#define | AGS_LEVEL_DEFAULT_UPPER
#define | AGS_LEVEL_DEFAULT_NORMALIZED_VOLUME
#define | AGS_LEVEL_DEFAULT_STEP_COUNT
#define | AGS_LEVEL_DEFAULT_PAGE_SIZE
#define | AGS_LEVEL_DEFAULT_DATA_FORMAT
#define | AGS_LEVEL_DEFAULT_SAMPLERATE
enum | AgsLevelDataFormat
enum | AgsLevelButtonState
enum | AgsLevelKeyMask
enum | AgsLevelAction

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkWidget
                ╰── AgsLevel

## Includes

    #include <ags/widget/ags_level.h>

## Description

AgsLevel is a widget that shows you a meter.

## Functions

### ags_level_set_upper ()

    void
    ags_level_set_upper (AgsLevel *level,
                         gdouble upper);

Set `upper` of `level` .

#### Parameters

level | the AgsLevel |
upper | the upper |

Since: 3.2.2

### ags_level_get_upper ()

    gdouble
    ags_level_get_upper (AgsLevel *level);

Get upper of `level` .

#### Parameters

level | the AgsLevel |

#### Returns

the upper

Since: 3.2.2

### ags_level_set_lower ()

    void
    ags_level_set_lower (AgsLevel *level,
                         gdouble lower);

Set `lower` of `level` .

#### Parameters

level | the AgsLevel |
lower | the lower |

Since: 3.2.2

### ags_level_get_lower ()

    gdouble
    ags_level_get_lower (AgsLevel *level);

Get lower of `level` .

#### Parameters

level | the AgsLevel |

#### Returns

the lower

Since: 3.2.2

### ags_level_set_normalized_volume ()

    void
    ags_level_set_normalized_volume (AgsLevel *level,
                                     gdouble normalized_volume);

Set `normalized_volume` of `level` .

#### Parameters

level | the AgsLevel |
normalized_volume | the normalized volume |

Since: 3.2.2

### ags_level_get_normalized_volume ()

    gdouble
    ags_level_get_normalized_volume (AgsLevel *level);

Get normalized volume of `level` .

#### Parameters

level | the AgsLevel |

#### Returns

the normalized volume

Since: 3.2.2

### ags_level_set_data_format ()

    void
    ags_level_set_data_format (AgsLevel *level,
                               AgsLevelDataFormat data_format);

Set data-format.

#### Parameters

level | the AgsLevel |
data_format | the data format |

Since: 5.1.0

### ags_level_set_samplerate ()

    void
    ags_level_set_samplerate (AgsLevel *level,
                              guint samplerate);

Set samplerate.

#### Parameters

level | the AgsLevel |
samplerate | the samplerate |

Since: 5.1.0

### ags_level_value_changed ()

    void
    ags_level_value_changed (AgsLevel *level,
                             gdouble normalized_volume);

Emits ::value-changed event.

#### Parameters

level | the AgsLevel |
normalized_volume | the normalized volume |

Since: 3.0.0

### ags_level_new ()

    AgsLevel *
    ags_level_new (GtkOrientation orientation,
                   guint width_request,
                   guint height_request);

Create a new instance of AgsLevel.

#### Parameters

orientation | the GtkOrientation |
width_request | the level's width |
height_request | the level's height |

#### Returns

the new AgsLevel instance

Since: 3.0.0

## Types and Values

### AGS_LEVEL_DEFAULT_WIDTH_REQUEST

    #define AGS_LEVEL_DEFAULT_WIDTH_REQUEST (60)

### AGS_LEVEL_DEFAULT_HEIGHT_REQUEST

    #define AGS_LEVEL_DEFAULT_HEIGHT_REQUEST (256)

### AGS_LEVEL_DEFAULT_LOWER

    #define AGS_LEVEL_DEFAULT_LOWER (0.0)

### AGS_LEVEL_DEFAULT_UPPER

    #define AGS_LEVEL_DEFAULT_UPPER (1.0)

### AGS_LEVEL_DEFAULT_NORMALIZED_VOLUME

    #define AGS_LEVEL_DEFAULT_NORMALIZED_VOLUME (0.0)

### AGS_LEVEL_DEFAULT_STEP_COUNT

    #define AGS_LEVEL_DEFAULT_STEP_COUNT (0.1)

### AGS_LEVEL_DEFAULT_PAGE_SIZE

    #define AGS_LEVEL_DEFAULT_PAGE_SIZE (0.25)

### AGS_LEVEL_DEFAULT_DATA_FORMAT

    #define AGS_LEVEL_DEFAULT_DATA_FORMAT (AGS_LEVEL_PCM_S16)

### AGS_LEVEL_DEFAULT_SAMPLERATE

    #define AGS_LEVEL_DEFAULT_SAMPLERATE (44100)

### enum AgsLevelDataFormat

#### Members

AGS_LEVEL_PCM_S8 |  |
AGS_LEVEL_PCM_S16 |  |
AGS_LEVEL_PCM_S24 |  |
AGS_LEVEL_PCM_S32 |  |
AGS_LEVEL_PCM_S64 |  |
AGS_LEVEL_PCM_FLOAT |  |
AGS_LEVEL_PCM_DOUBLE |  |
AGS_LEVEL_PCM_COMPLEX |  |

### enum AgsLevelButtonState

#### Members

AGS_LEVEL_BUTTON_1_PRESSED |  |

### enum AgsLevelKeyMask

#### Members

AGS_LEVEL_KEY_L_CONTROL |  |
AGS_LEVEL_KEY_R_CONTROL |  |
AGS_LEVEL_KEY_L_SHIFT |  |
AGS_LEVEL_KEY_R_SHIFT |  |

### enum AgsLevelAction

#### Members

AGS_LEVEL_STEP_UP |  |
AGS_LEVEL_STEP_DOWN |  |
AGS_LEVEL_PAGE_UP |  |
AGS_LEVEL_PAGE_DOWN |  |

## Property Details

### The `“data-format”` property

      “data-format”              guint

The data format.

Owner: AgsLevel

Flags: Read / Write

Default value: 1

Since: 4.0.0

### The `“lower”` property

      “lower”                    double

The level's lower range.

Owner: AgsLevel

Flags: Read / Write

Default value: 0

Since: 3.0.0

### The `“normalized-volume”` property

      “normalized-volume”        double

The level's default value.

Owner: AgsLevel

Flags: Read / Write

Default value: 0

Since: 3.0.0

### The `“samplerate”` property

      “samplerate”               guint

The level's samplerate.

Owner: AgsLevel

Flags: Read / Write

Allowed values: [8000,5644800]

Default value: 44100

Since: 5.1.0

### The `“upper”` property

      “upper”                    double

The level's upper range.

Owner: AgsLevel

Flags: Read / Write

Default value: 1

Since: 3.0.0

## Signal Details

### The `“value-changed”` signal

    void
    user_function (AgsLevel *level,
                   double    normalized_volume,
                   gpointer  user_data)

The ::value-changed signal notifies about modified default value.

#### Parameters

level | the AgsLevel |
normalized_volume | the changed default value |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 3.0.0